> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Update credit memos

PUT https://rest.test.zuora.com/v1/credit-memos/bulk
Content-Type: application/json

**Notes:**

* This operation is only available if you have [Invoice Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement) enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information.
* You can update credit memos only if you have the user permission. See [Billing Roles](https://knowledgecenter.zuora.com/CF_Users_and_Administrators/A_Administrator_Settings/User_Roles/d_Billing_Roles) for more information.

Updates the basic and finance information about multiple credit memos. You can update a maximum of 50 credit memos in one single request.

Currently, Zuora supports updating tax-exclusive memo items, but does not support updating tax-inclusive memo items. If the amount of a memo item is updated, the tax will be recalculated in the following conditions:

* The memo is created from a product rate plan charge and you use Avalara to calculate the tax.
* The memo is created from an invoice and you use Avalara or Zuora Tax to calculate the tax.

The Edit credit and debit memos tutorial demonstrates how to use this operation to add and delete memo items.

The credit memos that are updated are each in separate database transactions. If the update of one credit memo fails, other credit memos can still be updated successfully.

Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/billing-documents/credit-memos/put-update-credit-memos

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Headers

- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects a PUTBulkCreditMemosRequestType.

- `memos` (list of PUTCreditMemosWithIdType, optional) — The container for a list of credit memos. The maximum number of credit memos is 50.

## Response

### 200

OK

- `memos` (list of GETCreditMemoType, optional) — The container for a list of credit memos.
- `success` (boolean, optional) — Returns `true` if the request was processed successfully.

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### PUTCreditMemosWithIdType

Container for custom fields of a Credit Memo object.

- `id` (string, optional) — The ID of the credit memo.
- `autoApplyUponPosting` (boolean, optional) — Whether the credit memo automatically applies to the invoice upon posting.
- `comment` (string, optional) — Comments about the credit memo.
- `effectiveDate` (date, optional) — The date when the credit memo takes effect.
- `excludeFromAutoApplyRules` (boolean, optional) — Whether the credit memo is excluded from the rule of automatically applying unapplied credit memos to invoices and debit memos during payment runs. If you set this field to `true`, a payment run does not pick up this credit memo or apply it to other invoices or debit memos.
- `items` (list of PUTCreditMemoItemType, optional) — Container for credit memo items.
- `reasonCode` (string, optional) — A code identifying the reason for the transaction. The value must be an existing reason code or empty. If you do not specify a value, Zuora uses the default reason code.
- `transferredToAccounting` (enum, optional) — Whether the credit memo is transferred to an external accounting system. Use this field for integration with accounting systems, such as NetSuite.
  - Allowed values: `Processing`, `Yes`, `No`, `Error`, `Ignore`
- `IntegrationId__NS` (string, optional) — ID of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `IntegrationStatus__NS` (string, optional) — Status of the credit memo's synchronization with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `Origin__NS` (string, optional) — Origin of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `SyncDate__NS` (string, optional) — Date when the credit memo was synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `Transaction__NS` (string, optional) — Related transaction in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).

### GETCreditMemoType

Container for custom fields of a Credit Memo object.

- `accountId` (string, optional) — The ID of the customer account associated with the credit memo.
- `accountNumber` (string, optional) — The number of the customer account associated with the credit memo.
- `amount` (double, optional) — The total amount of the credit memo.
- `appliedAmount` (double, optional) — The applied amount of the credit memo.
- `autoApplyUponPosting` (boolean, optional) — Whether the credit memo automatically applies to the invoice upon posting.
- `billToContactId` (string, optional, nullable) — The ID of the bill-to contact associated with the credit memo. The value of this field is `null` if you have the [Flexible Billing Attributes](https://docs.zuora.com/en/zuora-billing/bill-your-customer/leverage-advanced-capabilities/flexible-billing/flexible-billing-attributes/overview-of-flexible-billing-attributes) feature disabled.
- `billToContactSnapshotId` (string, optional, nullable) — The ID of the bill-to contact snapshot associated with the credit memo. The value of this field is `null` if the bill rule [Preserve snapshot of bill-to and sold-to contacts when billing documents are posted](https://knowledgecenter.zuora.com/Zuora_Billing/Billing_and_Invoicing/Billing_Settings/Define_Billing_Rules#Preserve_snapshot_of_bill-to_and_sold-to_contacts_when_billing_documents_are_posted) is disabled.
- `cancelledById` (string, optional, nullable) — The ID of the Zuora user who cancelled the credit memo.
- `cancelledOn` (string, optional, nullable) — The date and time when the credit memo was cancelled, in `yyyy-mm-dd hh:mm:ss` format.
- `comment` (string, optional, nullable) — Comments about the credit memo.
- `createdById` (string, optional) — The ID of the Zuora user who created the credit memo.
- `createdDate` (string, optional) — The date and time when the credit memo was created, in `yyyy-mm-dd hh:mm:ss` format. For example, 2017-03-01 15:31:10.
- `creditMemoDate` (date, optional) — The date when the credit memo takes effect, in `yyyy-mm-dd` format. For example, 2017-05-20.
- `currency` (string, optional, nullable) — The currency of the credit memo. **Note:** By default, the currency on a billing document matches the default currency set on the associated account. However, Zuora now offers a Multiple Currencies feature to support different currencies for billing documents, allowing flexibility beyond the account-level currency. For more information, see Multiple Currency.
- `einvoiceErrorCode` (string, optional, nullable) — The error code returned when the e-invoice file status is `Failed`. This code can either be a Zuora-generated error code or one returned by a third-party e-invoicing service provider. **Note**: This field is available only if you have the E-Invoicing feature in **Early Adopter** phase enabled.
- `einvoiceErrorMessage` (string, optional, nullable) — The error message returned when the e-invoice file status is `Failed`. This message can either be a Zuora-generated error message or one returned by a third-party e-invoicing service provider. **Note**: This field is available only if you have the E-Invoicing feature in **Early Adopter** phase enabled.
- `einvoiceFileId` (string, optional, nullable) — The ID of the e-invoice file generated for the credit memo. **Note**: This field is available only if you have the E-Invoicing feature in **Early Adopter** phase enabled.
- `einvoiceStatus` (enum, optional, nullable) — The status of the e-invoice file generation for the credit memo. * If e-invoice file generation succeeds, this field is either `Generated` or `Success`, and both the error code and message are empty, and the `eInvoiceFileId` field stores the ID of the generated e-invoice file. * If the responses from tax vendors such as Sovos or Avalara are taking too long, this field becomes `RetrieveTimeOut`. Once the vendor responds successfully, you can use the 'Resync E-Invoice Status' action to update the status automatically. You can view these updates in System Health telemetry. * If a failure occurs during e-invoice file generation, this field is `Failed` and an error code and an error message are returned respectively in the `einvoiceErrorCode` and `einvoiceErrorMessage` fields. * If e-invoice file generation conditionally succeeds, this field is `ConditionalSuccess` and an error code and an error message are returned respectively in the `einvoiceErrorCode` and `einvoiceErrorMessage` fields. * If the e-invoice file has been approved by the tax authority, this field is `ApprovedByAuthority`. The next status will be either `Success` or `Rejected`. * If the e-invoice file has been rejected by the government, this field is `Rejected`. You cannot resend this e-invoice; you must create a new invoice instead. **Note**: This field is available only if you have the E-Invoicing feature in **Early Adopter** phase enabled.
  - Allowed values: `Processing`, `RetrieveTimeOut`, `Generated`, `Success`, `Failed`, `ConditionalSuccess`, `ApprovedByAuthority`, `Rejected`
- `excludeFromAutoApplyRules` (boolean, optional) — Whether the credit memo is excluded from the rule of automatically applying credit memos to invoices.
- `excludeItemBillingFromRevenueAccounting` (boolean, optional) — The flag to exclude the credit memo item from revenue accounting. **Note**: This field is only available if you have the Billing - Revenue Integration feature enabled.
- `id` (string, optional) — The unique ID of the credit memo.
- `invoiceGroupNumber` (string, optional, nullable) — The number of the invoice group associated with the credit memo. The value of this field is `null` if you have the [Flexible Billing Attributes](https://docs.zuora.com/en/zuora-billing/bill-your-customer/leverage-advanced-capabilities/flexible-billing/flexible-billing-attributes/overview-of-flexible-billing-attributes) feature disabled.
- `latestPDFFileId` (string, optional, nullable) — The ID of the latest PDF file generated for the credit memo.
- `number` (string, optional) — The unique identification number of the credit memo.
- `organizationLabel` (string, optional) — The organization that this object belongs to. Note: This field is available only when the Multi-Org feature is enabled.
- `postedById` (string, optional, nullable) — The ID of the Zuora user who posted the credit memo.
- `postedOn` (string, optional, nullable) — The date and time when the credit memo was posted, in `yyyy-mm-dd hh:mm:ss` format.
- `reasonCode` (string, optional) — A code identifying the reason for the transaction. The value must be an existing reason code or empty.
- `referredInvoiceId` (string, optional, nullable) — The ID of a referred invoice.
- `refundAmount` (double, optional) — The amount of the refund on the credit memo.
- `revenueImpacting` (enum, optional, default: Yes) — Indicates whether this write off operation impacts the revenue. If `revenueImpacting` = `Yes`, the deferred revenue accounting code will be automatically selected from the associated invoice If `revenueImpacting` = `No`, users can select an accounting code such as bad-debt expense accounting code for the write off operation.
  - Allowed values: `Yes`, `No`
- `reversed` (boolean, optional) — Whether the credit memo is reversed.
- `sequenceSetId` (string, optional, nullable) — The ID of the sequence set associated with the credit memo. The value of this field is `null` if you have the [Flexible Billing Attributes](https://docs.zuora.com/en/zuora-billing/bill-your-customer/leverage-advanced-capabilities/flexible-billing/flexible-billing-attributes/overview-of-flexible-billing-attributes) feature disabled.
- `communicationProfileId` (string, optional, nullable) — The ID of the communication profile associated with the credit memo. **Note**: This field is available in the request body only if you have the Flexible Billing Attributes feature turned on. The value is `null` in the response body without this feature turned on.
- `source` (string, optional) — The source of the credit memo. Possible values: - `BillRun`: The credit memo is generated by a bill run. - `API`: The credit memo is created by calling the [Invoice and collect](https://developer.zuora.com/api-references/api/operation/POST_TransactionInvoicePayment) operation, or by calling the Orders, Order Line Items, or Fulfillments API operations. - `ApiSubscribe`: The credit memo is created by calling the [Create subscription](https://developer.zuora.com/api-references/api/operation/POST_Subscription) and [Create account](https://developer.zuora.com/api-references/api/operation/POST_Account) operation. - `ApiAmend`: The credit memo is created by calling the [Update subscription](https://developer.zuora.com/api-references/api/operation/PUT_Subscription) operation. - `AdhocFromPrpc`: The credit memo is created from a product rate plan charge through the Zuora UI or by calling the [Create a credit memo from a charge](https://developer.zuora.com/api-references/api/operation/POST_CreditMemoFromPrpc) operation. - `AdhocFromInvoice`: The credit memo is created from an invoice or created by reversing an invoice. You can create a credit memo from an invoice through the Zuora UI or by calling the [Create credit memo from invoice](https://developer.zuora.com/api-references/api/operation/POST_CreditMemoFromInvoice) operation. You can create a credit memo by reversing an invoice through the Zuora UI or by calling the [Reverse invoice](https://developer.zuora.com/api-references/api/operation/PUT_ReverseInvoice) operation.
- `sourceId` (string, optional, nullable) — The ID of the credit memo source. If a credit memo is generated from a bill run, the value is the number of the corresponding bill run. Otherwise, the value is `null`.
- `sourceType` (enum, optional) — The type of the credit memo source.
  - Allowed values: `Subscription`, `Standalone`, `Invoice`, `Order`, `CreditMemo`, `Consolidation`
- `status` (enum, optional) — The status of the credit memo.
  - Allowed values: `Draft`, `Posted`, `Canceled`, `Error`, `PendingForTax`, `Generating`, `CancelInProgress`
- `success` (boolean, optional) — Returns `true` if the request was processed successfully.
- `targetDate` (date, optional, nullable) — The target date for the credit memo, in `yyyy-mm-dd` format. For example, 2017-07-20.
- `taxAmount` (double, optional) — The amount of taxation.
- `taxMessage` (string, optional, nullable) — The message about the status of tax calculation related to the credit memo. If tax calculation fails in one credit memo, this field displays the reason for the failure.
- `taxStatus` (enum, optional, nullable) — The status of tax calculation related to the credit memo. **Note**: This field is only applicable to tax calculation by third-party tax engines. Also, the `Voided` status indicates that the tax transaction is successfully canceled on the tax vendor's side. If a tax transaction was successfully committed to the third-party tax engine but the invoice failed to post, Zuora automatically detects the issue and voids the tax transaction on the vendor's side.
  - Allowed values: `Complete`, `Error`, `UnknownError`, `DuplicateDoc`, `InvalidRequest`, `InvalidResponse`, `TaxEngineError`, `ConcurrentModify`, `InternalServerError`, `TaxCodeTemplateError`, `Voided`
- `totalTaxExemptAmount` (double, optional) — The calculated tax amount excluded due to the exemption.
- `transferredToAccounting` (enum, optional) — Whether the credit memo was transferred to an external accounting system. Use this field for integration with accounting systems, such as NetSuite.
  - Allowed values: `Processing`, `Yes`, `No`, `Error`, `Ignore`
- `unappliedAmount` (double, optional) — The unapplied amount of the credit memo.
- `updatedById` (string, optional) — The ID of the Zuora user who last updated the credit memo.
- `updatedDate` (string, optional) — The date and time when the credit memo was last updated, in `yyyy-mm-dd hh:mm:ss` format. For example, 2017-03-01 15:36:10.
- `IntegrationId__NS` (string, optional) — ID of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `IntegrationStatus__NS` (string, optional) — Status of the credit memo's synchronization with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `Origin__NS` (string, optional) — Origin of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `SyncDate__NS` (string, optional) — Date when the credit memo was synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `Transaction__NS` (string, optional) — Related transaction in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### PUTCreditMemoItemType

Container for custom fields of a Credit Memo Item object.

- `amount` (double, optional) — The amount of the credit memo item. For tax-inclusive credit memo items, the amount indicates the credit memo item amount including tax. For tax-exclusive credit memo items, the amount indicates the credit memo item amount excluding tax
- `comment` (string, optional) — Comments about the credit memo item.
- `delete` (boolean, optional) — Whether to delete the existing credit memo item. **Note**: To delete a credit memo item, set this field to `true` and specify a credit memo item ID in the `id` field.
- `excludeItemBillingFromRevenueAccounting` (boolean, optional, default: false) — The flag to exclude the credit memo item from revenue accounting. **Note**: This field is only available if you have the Billing - Revenue Integration feature enabled.
- `financeInformation` (PutCreditMemoItemTypeFinanceInformation, optional) — Container for the finance information related to the credit memo item.
- `id` (string, optional) — The ID of the credit memo item. - Specify this field when updating or deleting an existing memo item. - Do not specify this field when creating a memo item.
- `quantity` (double, optional) — The number of units for the credit memo item.
- `productRatePlanChargeId` (string, optional) — The ID of the product rate plan charge that the credit memo is created from. **Note**: Do not specify the credit memo item `id` when specifying this field.
- `serviceEndDate` (date, optional) — The service end date of the credit memo item.
- `serviceStartDate` (date, optional) — The service start date of the credit memo item.
- `skuName` (string, optional) — The name of the SKU.
- `taxItems` (list of PutCreditMemoTaxItemType, optional) — Container for credit memo taxation items.
- `unitOfMeasure` (string, optional) — The definable unit that you measure when determining charges.

### PutCreditMemoItemTypeFinanceInformation

Container for the finance information related to the credit memo item.

- `deferredRevenueAccountingCode` (string, optional) — The accounting code for the deferred revenue, such as Monthly Recurring Liability.
- `onAccountAccountingCode` (string, optional) — The accounting code that maps to an on account in your accounting system.
- `recognizedRevenueAccountingCode` (string, optional) — The accounting code for the recognized revenue, such as Monthly Recurring Charges or Overage Charges.
- `revenueRecognitionRuleName` (string, optional) — The name of the revenue recognition rule governing the revenue schedule.

### PutCreditMemoTaxItemType

Container for custom fields of a Credit Taxation Item object.

- `id` (string, required) — The ID of the taxation item in the credit memo item.
- `amount` (double, optional) — The amount of the taxation item in the credit memo item.
- `financeInformation` (PutCreditMemoTaxItemTypeFinanceInformation, optional) — Container for the finance information related to the taxation item in the credit memo item.
- `jurisdiction` (string, optional) — The jurisdiction that applies the tax or VAT. This value is typically a state, province, county, or city.
- `locationCode` (string, optional) — The identifier for the location based on the value of the `taxCode` field.
- `taxCode` (string, optional) — The tax code identifies which tax rules and tax rates to apply to a specific credit memo.
- `taxCodeDescription` (string, optional) — The description of the tax code.
- `taxDate` (date, optional) — The date that the tax is applied to the credit memo, in `yyyy-mm-dd` format.
- `taxExemptAmount` (double, optional) — The calculated tax amount excluded due to the exemption.
- `taxName` (string, optional) — The name of taxation.
- `taxRate` (double, optional) — The tax rate applied to the credit memo.
- `taxRateDescription` (string, optional) — The description of the tax rate.
- `taxRateType` (enum, optional) — The type of the tax rate applied to the credit memo.
  - Allowed values: `Percentage`, `FlatFee`

### PutCreditMemoTaxItemTypeFinanceInformation

Container for the finance information related to the taxation item in the credit memo item.

- `onAccountAccountingCode` (string, optional) — The accounting code that maps to an on account in your accounting system.
- `salesTaxPayableAccountingCode` (string, optional) — The accounting code for the sales taxes payable.

## Examples

**Request**

```json
{
  "memos": [
    {
      "id": "402890555b797b57015b7986fc1a001f",
      "autoApplyUponPosting": false,
      "comment": "new comment",
      "effectiveDate": "2017-04-17",
      "excludeFromAutoApplyRules": false,
      "items": [
        {
          "amount": 1,
          "comment": "This is comment!",
          "id": "402890555b797b57015b7986fc1a001c",
          "quantity": 1,
          "serviceEndDate": "2016-11-30",
          "serviceStartDate": "2016-11-01",
          "skuName": "SKU-1",
          "taxItems": [
            {
              "id": "402890555b797b57015b7986fc3c001d",
              "amount": 0.03,
              "jurisdiction": "CALIFORNIA",
              "locationCode": "06",
              "taxCode": null,
              "taxCodeDescription": "This is tax code description!",
              "taxDate": "2016-11-30",
              "taxExemptAmount": 0,
              "taxName": "STATE TAX1",
              "taxRate": 0.0625,
              "taxRateDescription": "This is tax rate description!",
              "taxRateType": "Percentage"
            }
          ],
          "unitOfMeasure": "Test_UOM"
        },
        {
          "amount": 2,
          "comment": "This is comment!",
          "id": "402890555b797b57015b7986fc41001e",
          "serviceEndDate": "2016-11-30",
          "serviceStartDate": "2016-11-01",
          "skuName": "SKU-2",
          "taxItems": [],
          "unitOfMeasure": "Test_UOM"
        }
      ],
      "reasonCode": "Correcting invoice error"
    }
  ]
}
```

**Response**

```json
{
  "memos": [
    {
      "accountId": "ff8080817fe9d7b9017fe9e5234d04cb",
      "accountNumber": "A00000001",
      "amount": 100,
      "appliedAmount": 0,
      "autoApplyUponPosting": false,
      "billToContactId": null,
      "billToContactSnapshotId": null,
      "cancelledById": null,
      "cancelledOn": null,
      "comment": "test",
      "createdById": "ff8080817fe9d7b9017fe9e41732030e",
      "createdDate": "2022-04-02 18:49:47",
      "creditMemoDate": "2022-04-02",
      "currency": "USD",
      "einvoiceErrorCode": null,
      "einvoiceErrorMessage": null,
      "einvoiceFileId": null,
      "einvoiceStatus": "Processing",
      "excludeFromAutoApplyRules": false,
      "id": "ff8080817fe9d7b9017fe9e5382f04f5",
      "invoiceGroupNumber": "N-0001",
      "latestPDFFileId": "ac1ebc24569sd",
      "number": "CM00000001",
      "postedById": null,
      "postedOn": null,
      "reasonCode": "Correcting invoice error",
      "referredInvoiceId": "ff8080817fe9d7b9017fe9e5317f04e0",
      "refundAmount": 0,
      "reversed": false,
      "sequenceSetId": null,
      "source": "AdhocFromInvoice",
      "sourceId": null,
      "sourceType": "Invoice",
      "status": "Draft",
      "success": true,
      "targetDate": null,
      "taxAmount": 0,
      "taxMessage": null,
      "taxStatus": "Complete",
      "totalTaxExemptAmount": 0,
      "transferredToAccounting": "No",
      "unappliedAmount": 100,
      "updatedById": "ff8080817fe9d7b9017fe9e41732030e",
      "updatedDate": "2022-04-02 18:49:47"
    },
    {
      "id": "ff8080817fe9d7b9017fe9e41732030f",
      "success": false,
      "objectIndex": 1,
      "processId": "0356073CB721291A",
      "reasons": [
        {
          "code": 50000040,
          "message": "Cannot find a Invoice instance with id."
        }
      ]
    }
  ],
  "success": true
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/v1/credit-memos/bulk"

payload = { "memos": [
        {
            "id": "402890555b797b57015b7986fc1a001f",
            "autoApplyUponPosting": False,
            "comment": "new comment",
            "effectiveDate": "2017-04-17",
            "excludeFromAutoApplyRules": False,
            "items": [
                {
                    "amount": 1,
                    "comment": "This is comment!",
                    "id": "402890555b797b57015b7986fc1a001c",
                    "quantity": 1,
                    "serviceEndDate": "2016-11-30",
                    "serviceStartDate": "2016-11-01",
                    "skuName": "SKU-1",
                    "taxItems": [
                        {
                            "id": "402890555b797b57015b7986fc3c001d",
                            "amount": 0.03,
                            "jurisdiction": "CALIFORNIA",
                            "locationCode": "06",
                            "taxCode": None,
                            "taxCodeDescription": "This is tax code description!",
                            "taxDate": "2016-11-30",
                            "taxExemptAmount": 0,
                            "taxName": "STATE TAX1",
                            "taxRate": 0.0625,
                            "taxRateDescription": "This is tax rate description!",
                            "taxRateType": "Percentage"
                        }
                    ],
                    "unitOfMeasure": "Test_UOM"
                },
                {
                    "amount": 2,
                    "comment": "This is comment!",
                    "id": "402890555b797b57015b7986fc41001e",
                    "serviceEndDate": "2016-11-30",
                    "serviceStartDate": "2016-11-01",
                    "skuName": "SKU-2",
                    "taxItems": [],
                    "unitOfMeasure": "Test_UOM"
                }
            ],
            "reasonCode": "Correcting invoice error"
        }
    ] }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/v1/credit-memos/bulk';
const options = {
  method: 'PUT',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"memos":[{"id":"402890555b797b57015b7986fc1a001f","autoApplyUponPosting":false,"comment":"new comment","effectiveDate":"2017-04-17","excludeFromAutoApplyRules":false,"items":[{"amount":1,"comment":"This is comment!","id":"402890555b797b57015b7986fc1a001c","quantity":1,"serviceEndDate":"2016-11-30","serviceStartDate":"2016-11-01","skuName":"SKU-1","taxItems":[{"id":"402890555b797b57015b7986fc3c001d","amount":0.03,"jurisdiction":"CALIFORNIA","locationCode":"06","taxCode":null,"taxCodeDescription":"This is tax code description!","taxDate":"2016-11-30","taxExemptAmount":0,"taxName":"STATE TAX1","taxRate":0.0625,"taxRateDescription":"This is tax rate description!","taxRateType":"Percentage"}],"unitOfMeasure":"Test_UOM"},{"amount":2,"comment":"This is comment!","id":"402890555b797b57015b7986fc41001e","serviceEndDate":"2016-11-30","serviceStartDate":"2016-11-01","skuName":"SKU-2","taxItems":[],"unitOfMeasure":"Test_UOM"}],"reasonCode":"Correcting invoice error"}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/credit-memos/bulk"

	payload := strings.NewReader("{\n  \"memos\": [\n    {\n      \"id\": \"402890555b797b57015b7986fc1a001f\",\n      \"autoApplyUponPosting\": false,\n      \"comment\": \"new comment\",\n      \"effectiveDate\": \"2017-04-17\",\n      \"excludeFromAutoApplyRules\": false,\n      \"items\": [\n        {\n          \"amount\": 1,\n          \"comment\": \"This is comment!\",\n          \"id\": \"402890555b797b57015b7986fc1a001c\",\n          \"quantity\": 1,\n          \"serviceEndDate\": \"2016-11-30\",\n          \"serviceStartDate\": \"2016-11-01\",\n          \"skuName\": \"SKU-1\",\n          \"taxItems\": [\n            {\n              \"id\": \"402890555b797b57015b7986fc3c001d\",\n              \"amount\": 0.03,\n              \"jurisdiction\": \"CALIFORNIA\",\n              \"locationCode\": \"06\",\n              \"taxCode\": null,\n              \"taxCodeDescription\": \"This is tax code description!\",\n              \"taxDate\": \"2016-11-30\",\n              \"taxExemptAmount\": 0,\n              \"taxName\": \"STATE TAX1\",\n              \"taxRate\": 0.0625,\n              \"taxRateDescription\": \"This is tax rate description!\",\n              \"taxRateType\": \"Percentage\"\n            }\n          ],\n          \"unitOfMeasure\": \"Test_UOM\"\n        },\n        {\n          \"amount\": 2,\n          \"comment\": \"This is comment!\",\n          \"id\": \"402890555b797b57015b7986fc41001e\",\n          \"serviceEndDate\": \"2016-11-30\",\n          \"serviceStartDate\": \"2016-11-01\",\n          \"skuName\": \"SKU-2\",\n          \"taxItems\": [],\n          \"unitOfMeasure\": \"Test_UOM\"\n        }\n      ],\n      \"reasonCode\": \"Correcting invoice error\"\n    }\n  ]\n}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/credit-memos/bulk")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"memos\": [\n    {\n      \"id\": \"402890555b797b57015b7986fc1a001f\",\n      \"autoApplyUponPosting\": false,\n      \"comment\": \"new comment\",\n      \"effectiveDate\": \"2017-04-17\",\n      \"excludeFromAutoApplyRules\": false,\n      \"items\": [\n        {\n          \"amount\": 1,\n          \"comment\": \"This is comment!\",\n          \"id\": \"402890555b797b57015b7986fc1a001c\",\n          \"quantity\": 1,\n          \"serviceEndDate\": \"2016-11-30\",\n          \"serviceStartDate\": \"2016-11-01\",\n          \"skuName\": \"SKU-1\",\n          \"taxItems\": [\n            {\n              \"id\": \"402890555b797b57015b7986fc3c001d\",\n              \"amount\": 0.03,\n              \"jurisdiction\": \"CALIFORNIA\",\n              \"locationCode\": \"06\",\n              \"taxCode\": null,\n              \"taxCodeDescription\": \"This is tax code description!\",\n              \"taxDate\": \"2016-11-30\",\n              \"taxExemptAmount\": 0,\n              \"taxName\": \"STATE TAX1\",\n              \"taxRate\": 0.0625,\n              \"taxRateDescription\": \"This is tax rate description!\",\n              \"taxRateType\": \"Percentage\"\n            }\n          ],\n          \"unitOfMeasure\": \"Test_UOM\"\n        },\n        {\n          \"amount\": 2,\n          \"comment\": \"This is comment!\",\n          \"id\": \"402890555b797b57015b7986fc41001e\",\n          \"serviceEndDate\": \"2016-11-30\",\n          \"serviceStartDate\": \"2016-11-01\",\n          \"skuName\": \"SKU-2\",\n          \"taxItems\": [],\n          \"unitOfMeasure\": \"Test_UOM\"\n        }\n      ],\n      \"reasonCode\": \"Correcting invoice error\"\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://rest.test.zuora.com/v1/credit-memos/bulk")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"memos\": [\n    {\n      \"id\": \"402890555b797b57015b7986fc1a001f\",\n      \"autoApplyUponPosting\": false,\n      \"comment\": \"new comment\",\n      \"effectiveDate\": \"2017-04-17\",\n      \"excludeFromAutoApplyRules\": false,\n      \"items\": [\n        {\n          \"amount\": 1,\n          \"comment\": \"This is comment!\",\n          \"id\": \"402890555b797b57015b7986fc1a001c\",\n          \"quantity\": 1,\n          \"serviceEndDate\": \"2016-11-30\",\n          \"serviceStartDate\": \"2016-11-01\",\n          \"skuName\": \"SKU-1\",\n          \"taxItems\": [\n            {\n              \"id\": \"402890555b797b57015b7986fc3c001d\",\n              \"amount\": 0.03,\n              \"jurisdiction\": \"CALIFORNIA\",\n              \"locationCode\": \"06\",\n              \"taxCode\": null,\n              \"taxCodeDescription\": \"This is tax code description!\",\n              \"taxDate\": \"2016-11-30\",\n              \"taxExemptAmount\": 0,\n              \"taxName\": \"STATE TAX1\",\n              \"taxRate\": 0.0625,\n              \"taxRateDescription\": \"This is tax rate description!\",\n              \"taxRateType\": \"Percentage\"\n            }\n          ],\n          \"unitOfMeasure\": \"Test_UOM\"\n        },\n        {\n          \"amount\": 2,\n          \"comment\": \"This is comment!\",\n          \"id\": \"402890555b797b57015b7986fc41001e\",\n          \"serviceEndDate\": \"2016-11-30\",\n          \"serviceStartDate\": \"2016-11-01\",\n          \"skuName\": \"SKU-2\",\n          \"taxItems\": [],\n          \"unitOfMeasure\": \"Test_UOM\"\n        }\n      ],\n      \"reasonCode\": \"Correcting invoice error\"\n    }\n  ]\n}")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://rest.test.zuora.com/v1/credit-memos/bulk', [
  'body' => '{
  "memos": [
    {
      "id": "402890555b797b57015b7986fc1a001f",
      "autoApplyUponPosting": false,
      "comment": "new comment",
      "effectiveDate": "2017-04-17",
      "excludeFromAutoApplyRules": false,
      "items": [
        {
          "amount": 1,
          "comment": "This is comment!",
          "id": "402890555b797b57015b7986fc1a001c",
          "quantity": 1,
          "serviceEndDate": "2016-11-30",
          "serviceStartDate": "2016-11-01",
          "skuName": "SKU-1",
          "taxItems": [
            {
              "id": "402890555b797b57015b7986fc3c001d",
              "amount": 0.03,
              "jurisdiction": "CALIFORNIA",
              "locationCode": "06",
              "taxCode": null,
              "taxCodeDescription": "This is tax code description!",
              "taxDate": "2016-11-30",
              "taxExemptAmount": 0,
              "taxName": "STATE TAX1",
              "taxRate": 0.0625,
              "taxRateDescription": "This is tax rate description!",
              "taxRateType": "Percentage"
            }
          ],
          "unitOfMeasure": "Test_UOM"
        },
        {
          "amount": 2,
          "comment": "This is comment!",
          "id": "402890555b797b57015b7986fc41001e",
          "serviceEndDate": "2016-11-30",
          "serviceStartDate": "2016-11-01",
          "skuName": "SKU-2",
          "taxItems": [],
          "unitOfMeasure": "Test_UOM"
        }
      ],
      "reasonCode": "Correcting invoice error"
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/credit-memos/bulk");
var request = new RestRequest(Method.PUT);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"memos\": [\n    {\n      \"id\": \"402890555b797b57015b7986fc1a001f\",\n      \"autoApplyUponPosting\": false,\n      \"comment\": \"new comment\",\n      \"effectiveDate\": \"2017-04-17\",\n      \"excludeFromAutoApplyRules\": false,\n      \"items\": [\n        {\n          \"amount\": 1,\n          \"comment\": \"This is comment!\",\n          \"id\": \"402890555b797b57015b7986fc1a001c\",\n          \"quantity\": 1,\n          \"serviceEndDate\": \"2016-11-30\",\n          \"serviceStartDate\": \"2016-11-01\",\n          \"skuName\": \"SKU-1\",\n          \"taxItems\": [\n            {\n              \"id\": \"402890555b797b57015b7986fc3c001d\",\n              \"amount\": 0.03,\n              \"jurisdiction\": \"CALIFORNIA\",\n              \"locationCode\": \"06\",\n              \"taxCode\": null,\n              \"taxCodeDescription\": \"This is tax code description!\",\n              \"taxDate\": \"2016-11-30\",\n              \"taxExemptAmount\": 0,\n              \"taxName\": \"STATE TAX1\",\n              \"taxRate\": 0.0625,\n              \"taxRateDescription\": \"This is tax rate description!\",\n              \"taxRateType\": \"Percentage\"\n            }\n          ],\n          \"unitOfMeasure\": \"Test_UOM\"\n        },\n        {\n          \"amount\": 2,\n          \"comment\": \"This is comment!\",\n          \"id\": \"402890555b797b57015b7986fc41001e\",\n          \"serviceEndDate\": \"2016-11-30\",\n          \"serviceStartDate\": \"2016-11-01\",\n          \"skuName\": \"SKU-2\",\n          \"taxItems\": [],\n          \"unitOfMeasure\": \"Test_UOM\"\n        }\n      ],\n      \"reasonCode\": \"Correcting invoice error\"\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["memos": [
    [
      "id": "402890555b797b57015b7986fc1a001f",
      "autoApplyUponPosting": false,
      "comment": "new comment",
      "effectiveDate": "2017-04-17",
      "excludeFromAutoApplyRules": false,
      "items": [
        [
          "amount": 1,
          "comment": "This is comment!",
          "id": "402890555b797b57015b7986fc1a001c",
          "quantity": 1,
          "serviceEndDate": "2016-11-30",
          "serviceStartDate": "2016-11-01",
          "skuName": "SKU-1",
          "taxItems": [
            [
              "id": "402890555b797b57015b7986fc3c001d",
              "amount": 0.03,
              "jurisdiction": "CALIFORNIA",
              "locationCode": "06",
              "taxCode": ,
              "taxCodeDescription": "This is tax code description!",
              "taxDate": "2016-11-30",
              "taxExemptAmount": 0,
              "taxName": "STATE TAX1",
              "taxRate": 0.0625,
              "taxRateDescription": "This is tax rate description!",
              "taxRateType": "Percentage"
            ]
          ],
          "unitOfMeasure": "Test_UOM"
        ],
        [
          "amount": 2,
          "comment": "This is comment!",
          "id": "402890555b797b57015b7986fc41001e",
          "serviceEndDate": "2016-11-30",
          "serviceStartDate": "2016-11-01",
          "skuName": "SKU-2",
          "taxItems": [],
          "unitOfMeasure": "Test_UOM"
        ]
      ],
      "reasonCode": "Correcting invoice error"
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/credit-memos/bulk")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```